 /* dshar.c	dshar Ver1.16 nide@nara-wu.ac.jp */
char	ver[] = "1.16";
 /* pay attention for undshar.sh if you change the format of output */

#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <fcntl.h>
#ifdef UNIX
#  include <sys/types.h>
#  include <sys/stat.h>
#else
#  include <io.h>
#endif
#ifdef FPRINTF_NOVAL
#  ifdef __TURBOC__
#    include <stdarg.h>
#  else
#    include <varargs.h>
#  endif
#  define ITOLMASK ((2L << (8 * sizeof(int) - 1)) - 1L)
#endif
#include "common.h"

long	curoffset = 0;
char	tmpcmd[] = "_tmp$$$$.com";

#ifdef UNIX /* optionsl parameters */
int	outbin = 0, intext = 0, convsjis = 0;
char	*toSJIS_use = NULL;
#endif

#if !defined(FPRINTF_NOVAL) && !defined(MSC4) && !defined(__TURBOC__)
#  define FPRINTF_CHK
#endif

#ifdef FPRINTF_CHK
char	chkmsg[] = "\
Output error, or fprintf() of your system doesn't return meaningful\n\
value. If the latter, please recompile me with '-DFPRINTF_NOVAL'.\n\
";
#endif

char	strbegin81[] = "\
echo off\r\n\
: This is a command.com archive, meaning:\r\n\
";

char	strbegin1[] = "\
:%2s1. Remove everything above the 'echo off' line.\r\n\
:  2. Save the resulting text in a batch file (XXXX.bat).\r\n\
:  3. Execute the batch file to create:\r\n\
";

char	strbegin82[] = ":%6s%s%s\r\n";

char	strbegin2[] = "\
: Existing files will NOT be overwritten unless '-c' option is specified.\r\n\
: This archive created: %s (by dshar Ver %s)\r\n\
:\r\n\
:  <NOTE> Do NOT modify this archive except adding extra commands\r\n\
:  at the marked position near the end of the file, because this\r\n\
:  archive DEPENDS on the positions of data in the file.\r\n\
\r\n\
:*\r\n\
";

char	strbegin3[] = "\
if X%%1 == X-_ goto 00S~\r\n\
if X%%1 == X-/ goto 00Z~\r\n\
if X%%1 == X-. goto 00R~\r\n\
if X%%1 == X-+ goto 00Q~\r\n\
if EXIST %%0.bat %%0 -. %%0.bat %%1\r\n\
%%0 -. %%0 %%1\r\n\
:00R~\r\n\
for %%%%i in (%%tmp%%. %%tmp%%) do\
 if EXIST %%%%i\\nul %%0 -+ %%%%i %%2 %%3\r\n\
%%0 -/ %s %%2 %%3\r\n\
:00Q~\r\n\
%%0 -/ %%2\\%s %%3 %%4\r\n\
: batch chain, not reached here\r\n\
\r\n\
";

char	strbegin4[] = "\
:%dA~\r\n\
%%2 :-=0d\r\n\
echo File already exists: skipping '%s'\r\n\
%%2 :-wait...=20\r\n\
goto %dB~\r\n\
";

char	strbegin5[] = "\
\r\n\
:00S~\r\n\
%%2 :-=0d\r\n\
if %%3 == 4 goto 00V~\r\n\
if %%3 == 3 goto 00U~\r\n\
if %%3 == 2 goto 00T~\r\n\
%%2 :-Failed to write file\r\n\
goto 00W~\r\n\
:00T~\r\n\
%%2 :-Archive modified, can't extract\r\n\
goto 00W~\r\n\
:00U~\r\n\
%%2 :-Can't modify attribute of file\r\n\
goto 00W~\r\n\
:00V~\r\n\
%%2 :-Can't modify time-stamp of file\r\n\
:00W~\r\n\
";

char	strbegin6[] = "\
if not EXIST %%4 goto :00Y~\r\n\
del %%4\r\n\
if EXIST %%4 goto :00X~\r\n\
%%2 :-=20(%%4 deleted)\r\n\
goto :00Y~\r\n\
:00X~\r\n\
%%2 :-=20(%%4 not deleted)\r\n\
:00Y~\r\n\
echo . Wait...\r\n\
del %%2\r\n\
goto end~of~archive\r\n\
:00Z~\r\n\
\r\n\
echo making extractor...\r\n\
";

char	strextr[] = "\
echo %s>%s %%2\r\n\
";

char	strheader1[] = "\
\r\n\
if EXIST %s if NOT X%%4 == X-c goto %dA~\r\n\
%%2 :-=0d\r\n\
echo %s%s\r\n\
%%2 :-=1b[%dC=1b[1A\r\n\
";

char	strheader2[] = "\
if NOT EXIST %s\\nul %%2 %s\r\n\
";

char	strheader81[] = "\
:|!\r\n\
";

char	strheader3[] = "\
%%2 :%lx < %%3 > %s\r\n\
:|\r\n\
";

char	strtrailer[] = "\
:|\r\n\
if NOT ERRORLEVEL 1 %%2 :%lx. < %s\r\n\
if NOT ERRORLEVEL 1 %%2 :%x/%s\r\n\
for %%%%i in (4 3 2 1) do if ERRORLEVEL %%%%i %%0 -_ %%2 %%%%i %s\r\n\
:%dB~\r\n\
";

char	strend[] = "\
%%2 :-=0d=1b[2K\r\n\
\r\n\
del %%2\r\n\
: (You may put any additional commands to be executed here)\r\n\
\r\n\
:end~of~archive\r\n\
";


void	diskfull()
{
	fputs("write failed (maybe disk full?)\n", stderr);
	exit(1);
}

char	*strtime()
{
	long	t;
	register char	*ts;

	time(&t);
	(ts = ctime(&t))[24] = '\0';
	return ts;
}

#ifndef FPRINTF_NOVAL
#  define xfprintf fprintf
#else
/*VARARGS*/
#ifdef __TURBOC__
int	xfprintf(f, p)
register FILE	*f;
char	*p;
#else
int	xfprintf(f, p, va_alist)
register FILE	*f;
register char	*p;
va_dcl
#endif
 /* a very small subset of fprintf() who returns a meaningful value. */
{
	int	retval = 0, digits, outlen, longp;

	union	{
		char	*s;
		long	l;
	} tmpval;
	va_list	ap;

#ifdef __TURBOC__
	va_start(ap, p);
#else
	va_start(ap);
#endif
	while(*p){
		if(*p != '%' || *++p == '%'){
			if(EOF == putc(*p, f)) goto err;
			retval++, p++;
			continue;
		}
		for(digits = 0; is_digit(*p); p++){
			digits *= 10, digits += *p - '0';
		}
		if(0 != (longp = (*p == 'l'))) p++;
		switch(*p){
		case 's':
			if(longp) goto insuff;
			tmpval . s = va_arg(ap, char *);
			outlen = strlen(tmpval . s);
			for(digits -= outlen; digits-- > 0; ){
				if(EOF == putc(' ', f)) goto err;
				retval++;
			}
			if(outlen != fwrite(tmpval . s, 1, outlen, f))
				goto err;
			retval += outlen;
			p++;
			continue;
		case 'd':
		case 'x':
			if(digits) goto insuff;
			if(longp){
				tmpval . l = va_arg(ap, long);
			} else {
				tmpval . l = (long)va_arg(ap, int);
			}
			if(*p == 'd'){
				outlen = xfprintld(f, tmpval . l);
			} else {
				if(!longp) tmpval . l &= ITOLMASK;
				outlen = xfprintlx(f, tmpval . l);
			}
			if(-1 == outlen) goto err;
			retval += outlen;
			p++;
			continue;
		default:
		insuff:
			fprintf(stderr, "Bug: insufficient xfprintf()\n");
			exit(1);
		}
	}
	va_end(ap);
	return(ferror(f) ? -1 : retval);
err:
	va_end(ap);
	return -1;
}

xfprintlx(f, l)
register FILE	*f;
long	l;
{
	long	lsft;
	int	retval = 0, c;

	lsft = (l >> 4) & ((1L << (8 * sizeof(long) - 4)) - 1L);
	if(lsft != 0L && -1 == (retval = xfprintlx(f, lsft))) return -1;
	c = (int)(l & 0x0f), putc(c + (c < 10 ? '0' : 'a' - 10), f);
	return(ferror(f) ? -1 : (retval + 1));
}

xfprintld(f, l)
register FILE	*f;
long	l;
{
	int	retval = 0, minusp = 0, minusmaxp = 0;
	
	if(l < 0L){
		if(EOF == putc('-', f)) return -1;
		minusp = 1;
		if(l == -l){
			l--; minusmaxp = 1;
		} else l = -l;
	}

	if(l / 10L != 0L && -1 == (retval = xfprintld(f, l / 10L))) return -1;
	if(EOF == putc((int)(l % 10L) + '0' + minusmaxp, f)) return -1;
	return(ferror(f) ? -1 : (minusp + retval + 1));
}
#endif /* FPRINTF_NOVAL */

void	encode(inf, outf)
register FILE	*inf;
FILE	*outf;
{
#define IUNIT 15
#define COUNT (0x2000 / (IUNIT * 3))
#define ISIZE (IUNIT * 3 * COUNT)
#define OSIZE ((IUNIT * 4 + 3) * COUNT)
#define DOT_C 1
	int	ilen, olen, bcount, dcount = 1, lcount = 0;
	register char	*p, *q, c;
	dstatic	char	ibuf[ISIZE], obuf[OSIZE];

	while((ilen = fread(ibuf, 1, ISIZE, inf)) != 0){
		if(!--dcount) (putc('.', stderr), dcount = DOT_C);
		if(ilen % 3) ibuf[ilen] = 0;
		p = ibuf, q = obuf, bcount = 0;
		while(ilen--){
			switch(bcount++){
			case 0:
				if(!lcount++) *q++ = ':';

				c = (*p >> 2) & 0x3f;
				c += (char)(c ? 0x20 : 0x60);
				*q++ = c;
				c = (*p++ & 0x3) << 4;
				break;
			case 1:
				c |= (*p >> 4) & 0xf;
				c += (char)(c ? 0x20 : 0x60);
				*q++ = c;
				c = (*p++ & 0xf) << 2;
				break;
			default /* case 2 */:
				c |= (*p >> 6) & 0x3;
				c += (char)(c ? 0x20 : 0x60);
				*q++ = c;
				c = (*p++ & 0x3f);
				c += (char)(c ? 0x20 : 0x60);
				*q++ = c;

				bcount = 0;
				if(lcount == IUNIT){
					*q++ = '\r'; *q++ = '\n';
					lcount = 0;
				}
				break;
			}
		}
		if(bcount){
			c += (char)(c ? 0x20 : 0x60);
			*q++ = c;
		}
		if(lcount){
			*q++ = '\r'; *q++ = '\n';
		}
		olen = q - obuf;
		if(olen != fwrite(obuf, 1, olen, outf)) diskfull();
		curoffset += (long)olen;
	}
}

void	makemkdir(outf, name, oldname)
FILE	*outf;
register char	*name;
char	*oldname;
{
	register char	*p, *q;

	for(p = name, q = (oldname == NULL ? "" : oldname); *p; p++, q++){
		if(!(*p == *q || isdelim(*p) && isdelim(*q))) break;
		if(iskanjipos(p)){
			if(p[1] != q[1]) break; else p++, q++;
		}
	}
	for(; *p; p++){
		if(iskanjipos(p)){
			p++;
			continue;
		}
		if(!isdelim(*p) || p == name || isdrvmk(p[-1]) ||
		   p[-1] == '.' &&
		    (name + 1 == p || isDelim(p[-2]) || p[-2] == '.'))
			continue;

		(q = dosname(name))[p - name] = '\0';
		curoffset += (long)xfprintf(outf, strheader2, q, q);
	}
}

#ifdef UNIX
/* ------------------------- using stat() ------------------------- */
dosmode(name)
register char	*name;
{
 	struct	stat	statbuf;

	if(0 != stat(name, &statbuf)) (perror(name), exit(1));
	return (statbuf . st_mode & S_IWRITE) ? 0x20 : 0x21;
}

long	dosdate(name)
register char	*name;
{
 	struct	stat	statbuf;
	register struct	tm	*tmbuf;

	if(0 != stat(name, &statbuf)) (perror(name), exit(1));
	tmbuf = localtime(&statbuf . st_mtime);
	if(tmbuf -> tm_year < 80) return 0x21L;
	if(tmbuf -> tm_year > 80 + 99) return 0xbf7dc79fL;
	return ((long)(tmbuf -> tm_year - 80) << 9) |
	       ((long)(tmbuf -> tm_mon + 1) << 5) |
	       ((long)(tmbuf -> tm_mday)) |
	       ((long)(tmbuf -> tm_hour) << 27) |
	       ((long)(tmbuf -> tm_min) << 21) |
	       ((long)(tmbuf -> tm_sec / 2) << 16);
}
#else /* UNIX */
/* ------------------------- using DOS func ------------------------- */
dosmode(name)
register char	*name;
{
	int	mode;

	if(0 != _dos_getfileattr(name, &mode)){
		fprintf(stderr, "%s: Can't get attribute\n", name);
		exit(1);
	}
	return mode;
}

long	dosdate(name)
register char	*name;
{
	int	fd;
	unsigned int	status, fdate, ftime;

	if(-1 == (fd = open(name, O_RDONLY))) (perror(name), exit(1));
	status = _dos_getftime(fd, &fdate, &ftime);
	close(fd);
	if(status){
		fprintf(stderr, "%s: Can't get time-stamp\n", name);
		exit(1);
	}
	return ((long)ftime << 16) | ((long)fdate & 0xffffL);
}
#endif /* MSDOS vs. UNIX */
/* ------------------------- End of DOS funcs ------------------------- */

#ifdef UNIX
char	*strcatsave(s, r)
register char	*s, *r;
{
	register char	*p;

	p = emalloc(NULL, strlen(s) + strlen(r) + 1);
	return(sprintf(p, "%s%s", s, r), p);
}

FILE	*txtrdopen(orgf) /* LF -> CR+LF, but trims ^Z */
register FILE	*orgf;
{
	static	char	*av[] = {
		"sed", "/^\032$/d\n/\r$/!s/$/\r/", NULL
		 /* I think this sed command with special characters
		    won't be garbled... */
	};

	return piperdopen(*av, av, orgf);
	 /* must call wait() afterward */
}

FILE	*sjisrdopen(orgf)
register FILE	*orgf; /* orgf is closed and new FILE is returned */
{
	static	char	*av[] = {
		"sh", "-c", NULL, NULL
	};

	av[2] = toSJIS_use;
	return piperdopen(*av, av, orgf);
	 /* must call wait() afterward */
}
#endif /* UNIX */

void	arc(outf, num, name, oldname)
FILE	*outf;
int	num;
register char	*name;
char	*oldname;
{
	register FILE	*inf;
	char	*dname;
	static	char	partofmsg[] = "extracting ";

#ifdef UNIX
	inf = fopen(name, "r");
	if(inf != NULL && convsjis) inf = sjisrdopen(inf);
	if(inf != NULL && intext) inf = txtrdopen(inf);
	if(inf == NULL) (perror(name), exit(1));
#else
	if(NULL == (inf = fopen(name, "rb")))
		(perror(unixname(name)), exit(1));
#endif
	fprintf(stderr, is8bit(name) ?
		"%s%s (filename contains 8bit code!) " : "%s%-16s ",
				"Saving ", unixname(name)); /* No CR */

	curoffset += (long)xfprintf(outf, strheader1, dosname(name), num,
				partofmsg, unixname(name),
				sizeof(partofmsg) + max(16, strlen(name)));
	makemkdir(outf, name, oldname); /* There still remain posibilities of
	  producing redundant mkdirs in archive */
	if(oldname == NULL) curoffset += (long)xfprintf(outf, strheader81);
	curoffset += (long)xfprintf(outf, strheader3, curoffset,
							dosname(name));
	encode(inf, outf);

	dname = dosname(name);
	curoffset += (long)xfprintf(outf, strtrailer, dosdate(name), dname,
#ifdef UNIX	
					dosmode(name), dname, dname, num);
#else
					dosmode(dname), dname, dname, num);
#endif
							
	fclose(inf);
#ifdef UNIX	
	if(convsjis) wait(NULL);
	if(intext) wait(NULL);
#endif
	putc('\n', stderr);
}

void	usage(com)
register char	*com;
{
	fprintf(stderr, "dshar Ver %s\n", ver);
#ifdef UNIX
	fprintf(stderr, "Usage: %s [-btk] [-v filter] ", com);
	fprintf(stderr, "FILE FILE... > ARCHIVE.bat\n");
#else
	fprintf(stderr, "Usage: %s FILE FILE... > ARCHIVE.bat\n", com);
#endif
	exit(1);
}

void	makeextr(outf)
FILE	*outf;
{
	register char	**pp;
	register char	flg = 1;
	extern	char	*comdata[];

	for(pp = comdata; *pp != NULL; pp++){
		curoffset += (long)xfprintf(outf, strextr, *pp, ">" + flg);
		flg = 0;
	}
}

void	vmain(ac, av, outf)
int	ac;
char	*av[];
register FILE	*outf;
{
	register int	tmpac;

	curoffset = (long)xfprintf(outf, strbegin81);
#ifdef FPRINTF_CHK
	if(curoffset != (long)sizeof(strbegin81) - 1L){
		fprintf(stderr, chkmsg);
		exit(1);
	}
#endif
	curoffset += (long)xfprintf(outf, strbegin1,
			isjapan() && have8bit(ac, av) ? "\201@" : "");
	for(tmpac = 0; tmpac < ac; tmpac++){
		curoffset += (long)xfprintf(outf, strbegin82,
		  "", unixname(av[tmpac]),
		  is8bit(av[tmpac]) ? " (filename contains 8bit code!)" : "");
		/* We doesn't use \t, so that we can restore archived files
		   correctly if the archive passed through filters which
		   convert tab to spaces */
	}
	curoffset += (long)xfprintf(outf, strbegin2, strtime(), ver);
	curoffset += (long)xfprintf(outf, strbegin3, tmpcmd, tmpcmd);
	for(tmpac = 0; tmpac < ac; tmpac++){
		curoffset += (long)xfprintf(outf, strbegin4, tmpac, 
						unixname(av[tmpac]), tmpac);
	}
	curoffset += (long)xfprintf(outf, strbegin5);
	curoffset += (long)xfprintf(outf, strbegin6);
	makeextr(outf);

	for(tmpac = 0; tmpac < ac; tmpac++)
		arc(outf, tmpac, av[tmpac], tmpac ? (av - 1)[tmpac] : NULL);
	curoffset += (long)xfprintf(outf, strend);
	fflush(outf);
	if(ferror(outf)) diskfull();
#ifndef UNIX
	if(!isatty(fileno(outf)) && curoffset != ftell(outf)){
		fputs("write size mismatch. bug?\n", stderr);
		exit(1);
	}
#endif
}

#ifdef UNIX
addenv(s)
char	*s;
{
	extern	char	**environ;
	char	**newenv;
	register char	**pp, *p, *q, **qq;

	for(pp = environ; *pp != NULL; pp++){
		for(p = *pp, q = s; *p == *q && *p; p++, q++){
			if(*p == '='){
				*pp = s;
				return 0;
			}
		}
	}
	if(NULL == (newenv = (char **)calloc(
					(pp - environ) + 2, sizeof(char *))))
		return -1; /* should be realloc()? */
	for(pp = environ, qq = newenv; *pp != NULL; pp++, qq++) *qq = *pp;
	*qq++ = s;
	*qq = NULL;
	environ = newenv;
	return 0;
}
#endif

void	main(ac, av)
int	ac;
char	*av[];
{
	register FILE	*outf;
	extern	void	setargs();
#ifdef UNIX
	extern	int	optind;
	extern	char	*optarg;
	int	c;

	if(0 != addenv("LC_CTYPE=C")){
	 /* To make locale void. Must be in main().
	    Some machines have setenv() in place of putenv()... */
		perror(NULL), exit(1);
	}
	while(EOF != (c = getopt(ac, av, "tbkv:"))){
		switch(c){
		case 't':
			intext = 1; break;
		case 'b':
			outbin = 1; break;
		case 'k':
			convsjis = 1; break;
		case 'v':
			toSJIS_use = optarg; break;
		default:
			usage(*av);
		}
	}
	if(outbin){
		outf = stdout;
	} else {
		if(NULL == (outf = popen("exec tr -d '\\015'", "w")))
			(perror("tr"), exit(1));
	}
	if(convsjis){
		if(toSJIS_use == NULL) toSJIS_use = getenv("TOSJIS");
		if(toSJIS_use == NULL) toSJIS_use = TOSJIS_def;
		fprintf(stderr, "Kanji conversion command: \"%s\"\n",
								toSJIS_use);
		toSJIS_use = strcatsave("exec ", toSJIS_use);
		if(toSJIS_use == NULL) (perror(NULL), exit(1));
	}

	setargs(&ac, &av, optind - 1);
	if(0 == (ac -= optind)){
		fputs("No files specified\n", stderr);
		usage(*av);
	} else av += optind;
#else
	outf = stdout;
	setmode(fileno(outf), O_BINARY);
	setargs(&ac, &av, 0);
	if(!--ac){
		fputs("No files specified\n", stderr);
		usage(dosname(*av));
	} else av++;
#endif

	vmain(ac, av, outf);
	exit(0);
}
